; --- EXE body ---

                .model small
                .386

HotKey_scancode equ     87                   ; F11
HotKey_special1 equ     00000010b or (00000000b shl 8) ; 0040:0017 & 18 Lshift
HotKey_special2 equ     00000001b or (00000000b shl 8) ; 0040:0017 & 18 Rshift

request         equ     'CDpl'               ; Must be unique
response        equ     'ayer'

                include cd-play.mac


                .code
resident_body_begin:                         ; Here is begin of resident part

                TSR_PSP         dw ?         ; Seg of Environment (to uninstal)
                DriveNo         db 4

                FALSE           equ 0
                TRUE            equ 1
                i10_working     db FALSE     ; Status of most important ints
                i13_working     db FALSE
                i21_working     db FALSE
                i28_working     db FALSE     ; DOS working ?

                active          db FALSE     ; Preserve multiple activation
                count_down      db 0
                lets_run        db FALSE     ; Request for activation

                x_beg           db  1        ; Position of left-top corner
                y_beg           db  5
                active_page     db  ?        ; Active page
                actual_color    db  14       ; Used by macro SetColor and PutChar
                Max_In_Line     db  ?        ; Max chars in Line (to center CD-player)
                blink_status    db  ?        ; Blink Status
                xyLSBold        db  ?        ; Cursor position before activate
                xyMSBold        db  ?        ;        -- on VGA's regs --
                BIOS_xy         dw  ?        ; Like above but on BIOS vars
                shape_DW        dw  ?        ; Cursor-Shape before (on VGA's regs)

                include design.inc           ; Design, buttons and so on...

                Track2Play      db  1        ; Says PlayFromPos or Play_Audio
                                             ; which track must be played
                PosToPlay       dd  ?        ; Used by: proc PlayFromPos

                Rewind_value    equ 750      ; val = sec*75 (FF and FB)
                Volume_value    equ 10       ; o ile zwik/zmnie
                Wait_count      equ 5*18     ; 5sec

                _Unknown_       equ 0        ; (unused)
                Playing         equ 1
                Stopped         equ 2
                Paused          equ 3
                AudioStatus     db  _Unknown_; Audio Status
                CDROMstatus     db  0        ; Only 1st byte (E.g. door open)
                Lowest_track    db  ?        ; Lowest available track on CD
                Highest_track   db  ?        ; Highest available track on CD
                Last_track_pos  dd  ?        ; Last track position (in RED?)
                Current_track   db  ?        ; Actual Played track
                Total_Min       db  ?        ; Total Time (counted from begin)
                Total_Sec       db  ?
;                Total_Frame     db  ?    -- unused --
                Track_Min       db  ?        ; Track Time
                Track_Sec       db  ?
;                Track_Frame     db  ?    -- unused --
                Max_Min         db  ?        ; Maximum time on CD
                Max_Sec         db  ?
;                Max_Frame       db  ?    -- unused --



;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
int_08_handler  proc    far
                pushf
                                db 9Ah               ; FAR CALL
                old_ofs_08h     dw ?
                old_seg_08h     dw ?

                cmp     cs:[lets_run],TRUE
                jnz     return_09
                call    check4activation
return_09:      iret

int_08_handler  endp

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
int_09_handler  proc    far
                push    ax
                in      al,60h               ; Get Scan-Code
                cmp     al,HotKey_scancode
                jnz     launch_handler
                push    es                   ; Was special-key pressed ?
                xor     ax,ax
                mov     es,ax
                mov     ax,word ptr es:[417h]
                pop     es
                and     ax,0fh               ; Clear Num, Caps, Scroll lock
                cmp     ax,HotKey_special1
                jz      Combination_ok
                cmp     ax,HotKey_special2
                jz      Combination_ok
launch_handler:
                pop     ax
                                db 0EAh            ; FAR JMP
                old_ofs_09h     dw ?
                old_seg_09h     dw ?               ; Call previous handler

Combination_ok:
;                push    es
;                xor     ax,ax
;                mov     es,ax
;                and     es:[417h],NOT (HotKey_special1 or HotKey_special2)
;                pop     es
                in      al,61h                     ; To KeyBoard message
                mov     ah,al
                or      al,80h
                out     61h,al
                mov     al,ah
                out     61h,al
                mov     al,20h                     ; EOI
                out     20h,al
                mov     cs:[lets_run],TRUE
                mov     byte ptr cs:[count_down],wait_count ; Wait "n" ticks
                call    Check4activation
                pop     ax
                iret
int_09_handler  endp

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
int_10_handler  proc    far
                cmp     ax,0FFFFh            ; Our "check for resident" entry
                jnz     handler

                cmp     ebx,request          ; Caller checking for other copy
                jnz     handler
                mov     ebx,response         ; Yes, we are in memory
                mov     ax,cs                ; Caller can find TSR's PSP
                iret
handler:
                mov     cs:[i10_working],TRUE
                pushf
                                db 9Ah       ; FAR CALL
                old_ofs_10h     dw ?         ; Saved Vectors
                old_seg_10h     dw ?

                mov     cs:[i10_working],FALSE
                iret
int_10_handler  endp

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
int_13_handler  proc    far
                mov     cs:[i13_working],TRUE
                pushf
                                db 09Ah               ; FAR CALL
                old_ofs_13h     dw ?
                old_seg_13h     dw ?

                mov     cs:[i13_working],FALSE
                retf    2
int_13_handler  endp

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;int_21_handler  proc    far
;                mov     cs:[i21_working],TRUE
;                pushf
;                                db 0EAh               ; FAR CALL
;                old_ofs_21h     dw ?
;                old_seg_21h     dw ?
;
;iret
;                mov     cs:[i21_working],FALSE
;                retf    2
;int_21_handler  endp


;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
int_28_handler  proc    far
                mov     cs:[i28_working],TRUE
                cmp     cs:[lets_run],FALSE
                jz      handler_28
                call    Check4Activation
handler_28:
                pushf
                                db 09Ah              ; FAR CALL
                old_ofs_28h     dw ?
                old_seg_28h     dw ?

                mov     cs:[i28_working],FALSE
                iret
int_28_handler  endp


;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Check4activation proc   near                 ; Called from interrupt
                                             ; Must protect all changed interrupts
                cmp     cs:[lets_run],FALSE
                jz      dont_run
                cmp     cs:[active],TRUE
                jz      dont_run
                cmp     cs:[i13_working],TRUE
                jz      sys_busy
                cmp     cs:[i10_working],TRUE
                jz      sys_busy
;                cmp     cs:[i21_working],TRUE
;                jnz     sys_not_busy
;                cmp     cs:[i28_working],TRUE     ; Idle ?
;                jnz     sys_busy
sys_not_busy:
                call    CD_player
                ret

sys_busy:
                dec     byte ptr cs:[count_down]
;                cmp     byte ptr cs:[count_down],0
                jnz     dont_run
                mov     cs:[lets_run],FALSE
                push    ax
                mov     al,07         ; Unable to activate (beep error)
                int     29h
                pop     ax
dont_run:
                ret
Check4activation endp


;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
CD_player       proc    near
                mov     cs:[active],TRUE
                mov     cs:[lets_run],FALSE
                pushad
                push    ds
                push    es

                call    SaveSettings
                jc      ending            ; Incorrect text-mode
                call    SaveCRTval
                mov     ah,01h
                mov     cx,2020h
                int     10h               ; Hide da Cursor
                mov     al,cs:[Max_In_Line]
                shr     al,1
                sub     al,screen_width/2+1
                mov     cs:[x_beg],al     ; Keep CD-player in center (horiz)
                call    SaveBackground
                call    PaintScreen
                call    SetDisplayColor
                call    HandleEvents      ; Main CD-play control LOOP
                call    RestoreBackground
                call    RestoreCRTval

ending:
                pop     es
                pop     ds
                popad
                mov     cs:[active],FALSE
                mov     cs:[lets_run],FALSE
                ret
CD_player       endp


;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
HandleEvents    proc    near
                call    GetAllInfos
;                call    UpDateDisplay
                call    PaintButtons
wait4keypress:
                call    GetAllInfos
                call    KeyPressed
                jnz     Read_Key
                call    UpDateDisplay
                call    KeyPressed
                jnz     Read_Key
                mov     dx,60000
                call    Delay
                call    KeyPressed
                jz      wait4keypress
Read_key:
                call    ReadKey
                cmp     al,27
                jnz     next_00
                jmp     return_01
next_00:        and     al,0DFh
                cmp     al,"P"
                jnz     next_01
                mov     cs:[track2play],1
                call    Play_Audio
                jmp     End_Events
next_01:
                cmp     al,"O"
                jnz     next_02
                call    Open_Tray
                jmp     End_Events
next_02:        cmp     al,"C"
                jnz     next_08
                call    Close_Tray
                jmp     End_Events
next_08:        cmp     al,"S"
                jnz     next_03
                call    Stop_Audio
                call    Stop_Audio
                jmp     End_Events
next_03:        cmp     al,0
                jnz     next_04
                mov     al,ah
                cmp     al,75      ; Left
                jnz     next_03_01
                cmp     cs:[selected],1
                jz      wrap_01
                dec     cs:[selected]
                jmp     End_Events
wrap_01:        mov     cs:[selected],MaxToSelect
                jmp     End_Events
next_03_01:     cmp     al,77      ; Right
                jnz     next_03_02
                cmp     cs:[selected],MaxToSelect
                jz      wrap_02
                inc     cs:[selected]
                jmp     End_Events
wrap_02:        mov     cs:[selected],1
                jmp     End_Events
next_03_02:
                jmp     End_Events
next_04:        cmp     al,13      ; Enter
                jnz     next_05
                call    RunCommand
                jmp     End_Events
next_05:
                mov     al,07
                int     29h
End_Events:
                call    PaintButtons
check4key:      call    KeyPressed     ; Clean Da Keyboard Buffer
                jz      not_pressed
                call    readkey
                jmp     check4key
not_pressed:
                jmp     wait4keypress
return_01:
                ret
HandleEvents    endp


RunCommand      proc    near
                mov     al,cs:[selected]
                cmp     al,Btn_Play_no      ; Play
                jnz     run_01
                mov     cs:[track2play],1
                call    Play_Audio
                jmp     return_04
run_01:         cmp     al,Btn_Stop_no      ; Stop
                jnz     run_02
                call    Stop_Audio
                call    Stop_Audio          ; Ensure that will be stop
                jmp     return_04
run_02:         cmp     al,Btn_Tray_no      ; Open/Close Tray
                jnz     run_03
                mov     al,byte ptr cs:[CDROMstatus]
                test    al,1                ; Are Doors closed or maybe open
                jz      Eject_tray          ; Open
                call    Close_Tray
                jmp     return_04
Eject_tray:     call    Open_Tray           ; Close
                jmp     return_04
run_03:         cmp     al,Btn_Pause_no     ; Pause
                jnz     run_04
                cmp     byte ptr cs:[AudioStatus],paused
                jz      _resume
                cmp     byte ptr cs:[AudioStatus],stopped
                jz      return_04
                call    Stop_Audio
                jmp     return_04
_resume:        call    Resume_Audio        ; Resume
                jmp     return_04
run_04:         cmp     al,Btn_Next_no      ; Next Track
                jnz     run_05
                mov     al,cs:[current_track]
                mov     cs:[track2play],al
                inc     al
                cmp     al,cs:[Highest_Track]
                jg      return_04           ; When greater
                mov     cs:[track2play],al
                call    Play_Audio
                jmp     return_04
run_05:         cmp     al,Btn_Back_no      ; Back Track
                jnz     run_06
                mov     al,cs:[current_track]
                mov     cs:[track2play],al
                dec     al
                cmp     al,cs:[Lowest_Track]
                jb      return_04           ; When smaller
                mov     cs:[track2play],al
                call    Play_Audio
                jmp     return_04
run_06:         cmp     al,Btn_FB_no        ; Fast Back
                jnz     run_07
                mov     ax,-Rewind_value
                call    Rewind_Audio
                jmp     return_04
run_07:         cmp     al,Btn_FF_no        ; Fast Forward
                jnz     run_08
                mov     ax,+Rewind_value
                call    Rewind_Audio
                jmp     return_04
run_08:         cmp     al,Btn_VolU_no      ; Louder
                jnz     run_09
                call    Volume_Up
                jmp     return_04
run_09:         cmp     al,Btn_VolD_no      ; Ciszej
                jnz     run_10
                call    Volume_Down
                jmp     return_04

run_10:
return_04:
                ret
RunCommand      endp


GetAllInfos     proc    near
                call    GetAudioStatus
                call    GetDiskInfo
                call    GetQInfo
                call    GetCDROMStatus
                mov     al,byte ptr cs:[Last_track_pos+2]
                mov     byte ptr cs:[Max_Min],al
                mov     al,byte ptr cs:[Last_track_pos+1]
                mov     byte ptr cs:[Max_Sec],al
;                mov     al,byte ptr cs:[Last_track_pos]    -- unused --
;                mov     byte ptr cs:[Max_Frame],al
                ret
GetAllInfos     endp


;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


Play_Audio      proc    near
                mov     al,cs:[track2play]
                call    GetTrackPos
                call    Red2HSG
                mov     dword ptr cs:[PosToPlay],eax
                call    PlayFromPos
                ret
Play_Audio      endp


Resume_Audio    proc    near
                call    CleanUpRequest
                ValDBToArray Request_buffer  0   05      ; Len
                ValDBToArray Request_buffer  2  136      ; Command
                call    SendRequest
                ret
Resume_Audio    endp

Stop_Audio      proc    near
                call    CleanUpRequest
                ValDBToArray Request_buffer  0   05      ; Len
                ValDBToArray Request_buffer  2  133      ; Command
                call    SendRequest
                ret
Stop_Audio      endp

;Reset_Audio     proc    near
;                call    CleanUpRequest
;                call    CleanUpTrans
;                ValDBToArray Request_buffer  0   01      ; Len
;                ValDBToArray Request_buffer  2    2      ; Command
;                call    SendRequest
;                ret
;Reset_Audio     endp

GetAudioStatus  proc    near
                call    Fill2TransIN
                ValDWToArray Request_buffer 18   11      ; Data Len to transfer
                ValDBToArray Trans_buffer    0   15      ; Audio Status
                call    SendRequest
                mov     al,byte ptr cs:[Request_buffer+4]
                mov     ah,byte ptr cs:[Trans_Buffer+1]
                test    al,80h
                jnz     error
                test    al,2
                jnz     busy
                test    ah,1
                jnz     pausing
                mov     byte ptr cs:[AudioStatus],Stopped
                ret
busy:                            ; Means playing or (pausing I think)
                test    ah,1
                jnz     pausing
                mov     byte ptr cs:[AudioStatus],Playing
                ret
pausing:        mov     byte ptr cs:[AudioStatus],Paused
                ret
error:          mov     byte ptr cs:[AudioStatus],_Unknown_
                ret
GetAudioStatus  endp

Open_Tray       proc    near
                call    Fill2TransOUT
                ValDWToArray Request_buffer 18    1      ; Data Len to transfer
                ValDBToArray Trans_buffer    0    0      ; Eject
                call    SendRequest
                ret
Open_Tray       endp

Close_Tray      proc    near
                call    Fill2TransOUT
                ValDWToArray Request_buffer 18    1      ; Data Len to transfer
                ValDBToArray Trans_buffer    0    5      ; Close
                call    SendRequest
                ret
Close_Tray      endp

Rewind_Audio    proc    near
                cmp     byte ptr cs:[AudioStatus],playing
                jnz     return_05
                push    ax
                call    Fill2TransIN
                ValDWToArray Request_buffer 18    6      ; Data Len to transfer
                ValDBToArray Trans_buffer    0    1      ; Head position
                call    SendRequest
                pop     ax
                mov     ebx,dword ptr cs:[Trans_Buffer+2] ; Actual Head position
                movsx   eax,ax       ; Uzup do DWORD liczby ze znakiem
                add     ebx,eax      ; /or SUB ('cos EAX may be negative)
                push    ebx
                mov     eax,cs:[Last_Track_Pos]  ; Get Last Possible Position
                call    Red2HSG
                pop     ebx
                cmp     ebx,eax      ; Check if jump beyond last postion
                jg      return_05    ; Not Able to jump beyond last position
                push    ebx
                mov     al,1
                call    GetTrackPos
                call    Red2HSG
                pop     ebx
                cmp     ebx,eax
                jg      Lets_Rewind  ; Ok, jump between begin and end

                                     ; Not Able to Jump before 1st track pos
                mov     ebx,eax      ; So jump to 1st avilable sector (1st track)
Lets_rewind:
                mov     dword ptr cs:[PosToPlay],ebx
                call    PlayFromPos  ; Play new position
return_05:
                ret
Rewind_Audio    endp

PlayFromPos     proc    near
                cmp     byte ptr cs:[AudioStatus],stopped
                jz      ok_stopped
                call    Stop_Audio
                call    Stop_Audio
ok_stopped:
                call    CleanUpRequest
                ValDBToArray Request_buffer  0   22      ; Len
                ValDBToArray Request_buffer  2  132      ; Command

                mov     eax,dword ptr cs:[PosToPlay]
                RegDDToArray Request_buffer 14  EAX      ; Play From pos
                push    eax
                mov     eax,dword ptr cs:[last_track_pos]
                call    Red2HSG
                pop     ebx
                sub     eax,ebx
                RegDDToArray Request_buffer 18  EAX      ; Play few sectors
                call    SendRequest
                ret
PlayFromPos     endp


Volume_Up       proc    near
                call    GetCDVol
                mov     cl,Volume_Value
                add     byte ptr cs:[Trans_buffer+2],cl
                jnc     next_1
                mov     byte ptr cs:[Trans_buffer+2],0FFh
next_1:         add     byte ptr cs:[Trans_buffer+4],cl
                jnc     send_1
                mov     byte ptr cs:[Trans_buffer+4],0FFh
send_1:         mov     eax,dword ptr cs:[Trans_buffer+1]
                call    SetCDVol
return_12:
                ret
Volume_Up       endp

Volume_Down     proc    near
                call    GetCDVol
                mov     cl,Volume_Value
                sub     byte ptr cs:[Trans_buffer+2],cl
                jnc     next_2
                mov     byte ptr cs:[Trans_buffer+2],0
next_2:         sub     byte ptr cs:[Trans_buffer+4],cl
                jnc     send_2
                mov     byte ptr cs:[Trans_buffer+4],0
send_2:         mov     eax,dword ptr cs:[Trans_buffer+1]
                call    SetCDVol
return_11:
                ret
Volume_Down     endp


GetCDVol        proc    near                ; not OUT:   EAX - Channel Control
                call    Fill2TransIN
                ValDWToArray Request_buffer 18    9      ; Data Len to transfer
                ValDBToArray Trans_buffer    0    4      ; Get CD volume ctrl
                call    SendRequest
;                mov     eax,dword ptr cs:[Trans_buffer+1]
                ret
GetCDVol        endp

SetCDVol        proc    near                ; IN:    EAX - Channel Control
                push    eax
                call    Fill2TransOUT
                pop     eax
                ValDWToArray Request_buffer 18    9      ; Data Len to transfer
                ValDBToArray Trans_buffer    0    3      ; Set CD volume ctrl
                RegDDToArray Trans_buffer    1  EAX
                call    SendRequest
                ret
SetCDVol        endp

GetTrackPos     proc    near        ; IN:  AL  - Track
                                    ; OUT: EAX - Position
                push    ax
                call    Fill2TransIN
                pop     ax
                ValDWToArray Request_buffer 18    7      ; Data Len to transfer
                ValDBToArray Trans_buffer    0   11      ; Get Track Info
                RegDBToArray Trans_buffer    1   AL
                call    SendRequest
                mov     eax,dword ptr cs:[Trans_buffer+2]
                ret
GetTrackPos     endp

GetDiskInfo     proc    near
                call    Fill2TransIN
                ValDWToArray Request_buffer 18    7      ; Data Len to transfer
                ValDBToArray Trans_buffer    0   10      ; Get infos
                call    SendRequest
                mov     al,byte ptr cs:[Trans_buffer+1]
                mov     byte ptr cs:[Lowest_track],al
                mov     al,byte ptr cs:[Trans_buffer+2]
                mov     byte ptr cs:[Highest_track],al
                mov     eax,dword ptr cs:[Trans_buffer+3]
                mov     dword ptr cs:[Last_track_pos],eax
                ret
GetDiskInfo     endp


GetQInfo        proc    near
                call    Fill2TransIN
                ValDWToArray Request_buffer 18   11      ; Data Len to transfer
                ValDBToArray Trans_buffer    0   12      ; Get infos
                call    SendRequest
                movzx   ax,byte ptr cs:[Trans_buffer+2]
                mov     bx,ax            ; Convert BCD to binary value
                shr     al,4
                mov     cl,10
                mul     cl
                mov     cx,bx
                and     cx,0Fh
                add     ax,cx
                cmp     ax,100
                jb      SetTrack
                xor     ax,ax
SetTrack:       mov     byte ptr cs:[Current_track],al
                mov     al,byte ptr cs:[Trans_buffer+4]
                mov     byte ptr cs:[Track_Min],al
                mov     al,byte ptr cs:[Trans_buffer+5]
                mov     byte ptr cs:[Track_Sec],al
;                mov     al,byte ptr cs:[Trans_buffer+6]   -- unused --
;                mov     byte ptr cs:[Track_Frame],al

                mov     al,byte ptr cs:[Trans_buffer+8]
                mov     byte ptr cs:[Total_Min],al
                mov     al,byte ptr cs:[Trans_buffer+9]
                mov     byte ptr cs:[Total_Sec],al
;                mov     al,byte ptr cs:[Trans_buffer+10]  -- unused --
;                mov     byte ptr cs:[Total_Frame],al

                ret
GetQInfo        endp


GetCDROMStatus  proc    near
                call    Fill2TransIN
                ValDWToArray Request_buffer 18    5      ; Data Len to transfer
                ValDBToArray Trans_buffer    0    6      ; Get Status
                call    SendRequest
;                mov     eax,dword ptr cs:[Trans_buffer+1]   Nie potrzebny
;                mov     dword ptr cs:[CDROMstatus],eax      cay status -
;                                                            tylko 1st byte
                mov     al,byte ptr cs:[Trans_buffer+1]
                mov     byte ptr cs:[CDROMstatus],al
                ret
GetCDROMStatus  endp


CleanUpRequest  proc    near
                xor     ax,ax
                push    cs
                pop     es
                mov     di,offset Request_buffer
                mov     cx,Request_buffer_len
                cld
                rep     stosb
                ret
CleanUpRequest  endp

CleanUpTrans    proc    near
                xor     ax,ax
                push    cs
                pop     es
                mov     di,offset Trans_buffer
                mov     cx,Trans_buffer_len
                cld
                rep     stosb
                ret
CleanUpTrans    endp

Fill2TransOUT   proc    near
                call    CleanUpRequest
                call    CleanUpTrans
                ValDBToArray Request_buffer  0   26      ; Len
                ValDBToArray Request_buffer  2  012      ; Command
                ValDWToArray Request_buffer 14  <offset Trans_buffer>
                RegDWToArray Request_buffer 16   CS
                ret
Fill2TransOUT   endp

Fill2TransIN    proc    near
                call    CleanUpRequest
                call    CleanUpTrans
                ValDBToArray Request_buffer  0   26      ; Len
                ValDBToArray Request_buffer  2  003      ; Command
                ValDWToArray Request_buffer 14  <offset Trans_buffer>
                RegDWToArray Request_buffer 16   CS
                ret
Fill2TransIN    endp

SendRequest     proc    near
                mov     ax,1510h
                movzx   cx,cs:[DriveNo]
                push    cs
                pop     es
                mov     bx,offset Request_buffer
                int     2fh
                ret
SendRequest     endp


Red2HSG         proc    near
                push    eax       ; Save Value
                shr     eax,16
                and     eax,0FFh
                mov     ebx,60*75 ; Minutes
                mul     ebx       ; EAX * 60*75 = (EDX):EAX
                mov     ecx,eax
                pop     eax       ; Restore Value
                push    eax       ; Save Value
                shr     eax,8
                and     eax,0FFh  ; Second
                mov     ebx,75
                mul     ebx
                add     ecx,eax
                pop     eax       ; Restore Value
                and     eax,0FFh  ; Frame
                sub     eax,150
                add     eax,ecx
                ret
Red2HSG         endp


;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

UpDateDisplay   proc    near
                SetColor Display_attr
                mov     dx,cs:[Dis_Low_xy]        ; To And Fro Tracks
                movzx   ax,cs:[Lowest_track]
                call    WriteDEC
                mov     dx,cs:[Dis_High_xy]
                movzx   ax,cs:[Highest_track]
                call    WriteDEC

                mov     dx,cs:[Dis_track_xy]      ; Actual Played Track
                movzx   ax,cs:[Current_track]
                call    WriteDEC

                mov     dx,cs:[Dis_Min_xy]        ; Minutes of Track
                movzx   ax,cs:[Track_Min]
                call    WriteDEC
                mov     dx,cs:[Dis_Sec_xy]        ; Seconds of Track
                movzx   ax,cs:[Track_Sec]
                call    WriteDEC

                mov     dx,cs:[Dis_CD_Min_xy]
                movzx   ax,cs:[Total_Min]         ; Total Minutes
                call    WriteDEC
                mov     dx,cs:[Dis_CD_Sec_xy]     ; Total Seconds
                movzx   ax,cs:[Total_Sec]
                call    WriteDEC

                mov     dx,cs:[Dis_Max_Min_xy]
                movzx   ax,cs:[Max_Min]           ; Maximum Minutes on CD
                call    WriteDEC

                mov     dx,cs:[Dis_Max_Sec_xy]
                movzx   ax,cs:[Max_Sec]           ; Maximum Second on CD
                call    WriteDEC

                call    PaintStatus
                ret
UpDateDisplay   endp

SetDisplayColor proc    near
                mov     dx,word ptr cs:[x_beg]   ; Load (X,Y) left-top corner
                inc     dl
                inc     dh
                SetColor display_attr
                call    WorkOnLine
                mov     dl,cs:[x_beg]
                inc     dl
                inc     dh
                call    WorkOnLine
                ret
WorkOnLine:
                mov     cx,display_width
ChangeBack:
                push    cx
                inc     dl
                call    GotoXY
                mov     ah,08h
                mov     bh,cs:[active_page]
                int     10h
                call    PutChar
                pop     cx
                loop    ChangeBack
                ret
SetDisplayColor endp


SaveBackground  proc    near
                mov     di,offset screen_buffer-2
                mov     dh,cs:[y_beg]
                dec     dh
y_line:         mov     dl,cs:[x_beg]
                dec     dl
                inc     dh
x_line:         inc     dl
                inc     di
                inc     di
                call    GotoXY

                mov     ah,08h
                mov     bh,cs:[active_page]
                int     10h
                mov     cs:[di],ax
                push    dx
                sub     dl,cs:[x_beg]
                cmp     dl,screen_width
                pop     dx
                jb      x_line
                cmp     di,offset screen_buffer+screen_height*screen_width*2
                jb      y_line      ; < or =
                ret
SaveBackground  endp

PaintScreen     proc    near
                mov     di,offset screen-1
                mov     dh,cs:[y_beg]
                dec     dh
y_line_:        mov     dl,cs:[x_beg]
                dec     dl
                inc     dh
x_line_:        inc     dl
                inc     di
                call    GotoXY

                SetColor <srn_back_attr>
                mov     al,cs:[di]
                call    PutChar
                push    dx
                sub     dl,cs:[x_beg]
                cmp     dl,screen_width
                pop     dx
                jb      x_line_
                cmp     di,offset screen+screen_height*screen_width
                jb      y_line_     ; < or =
                ret
PaintScreen     endp

RestoreBackground proc  near
                mov     di,offset screen_buffer-2
                mov     dh,cs:[y_beg]
                dec     dh
y_line__:       mov     dl,cs:[x_beg]
                dec     dl
                inc     dh
x_line__:       inc     di
                inc     di
                inc     dl

                call    GotoXY
                mov     al,cs:[di]
                mov     ah,cs:[di+1]
                SetColor <ah>
                call    PutChar
                push    dx
                sub     dl,cs:[x_beg]
                cmp     dl,screen_width
                pop     dx
                jb      x_line__
                cmp     di,offset screen_buffer+screen_height*screen_width*2
                jb      y_line__    ; < or =
                ret
RestoreBackground endp


SaveSettings    proc    near                 ; OUT: Set FC if not in text-mode
                mov     ah,0fh
                int     10h
                mov     cs:[active_page],bh
                mov     cs:[Max_in_line],ah
                mov     dx,3dah
                in      al,dx
                mov     dx,3c0h
                mov     al,10h or 100000b    ; 5bit - when =0 then screen off
                out     dx,al
                inc     dx
                in      al,dx                ; Get if text or grphx
                push    ax
                shr     al,3                 ; 3bit - status blink
                and     al,1                 ; Change 3b to 1D or 0D
                mov     cs:[Blink_Status],al
                pop     ax

                and     al,1                 ; When 1 then gpx, 0 text
                jz      Text_Mode
                stc
                ret
Text_mode:
                mov     ax,1003h             ; Disable Blink Status
                xor     bl,bl
                int     10h
                clc
                ret
SaveSettings    endp


SaveCRTval      proc    near              ; Saves shape and cursor postions
                mov     ah,03h
                int     10h
                mov     cs:[bios_xy],dx   ; Get BIOS' cursor positions
                mov     al,0eh
                call    read_port
                mov     cs:[xyLSBold],al
                mov     al,0fh
                call    read_port
                mov     cs:[xyMSBold],al
                mov     al,0bh            ; MSB of cursor shape
                call    read_port
                mov     ah,al
                mov     al,0ah            ; LSB of cursor shape
                call    read_port
                mov     word ptr cs:[shape_DW],ax
                ret
SaveCRTval      endp

RestoreCRTval   proc    near          ;  Restores shape and cursor positions
                mov     dx,cs:[bios_xy]
                call    GotoXY        ; Restore cursor pos in BIOS vars

                mov     ax,1003h
                mov     bl,cs:[Blink_Status]
                int     10h           ; Restore Blink Status

                mov     al,0eh
                mov     ah,cs:[xyLSBold]
                call    write_port
                mov     al,0fh
                mov     ah,cs:[xyMSBold]
                call    write_port
                mov     al,0ah
                mov     ah,byte ptr cs:[shape_DW]      ; LSB of cursor shape
                call    write_port
                mov     al,0bh
                mov     ah,byte ptr cs:[shape_DW+1]    ; MSB of cursor shape
                call    write_port
                ret
RestoreCRTval   endp

PaintButtons    proc    near
                mov     dx,cs:[Btn_FB_xy]
                mov     si,offset Btn_FB_txt
                MakeSelect<Btn_FB_no>
                call    WriteStr
                mov     dx,cs:[Btn_Back_xy]
                mov     si,offset Btn_Back_txt
                MakeSelect<Btn_Back_no>
                call    WriteStr
                mov     dx,cs:[Btn_Play_xy]
                mov     si,offset Btn_Play_txt
                MakeSelect<Btn_Play_no>
                call    WriteStr
                mov     dx,cs:[Btn_Next_xy]
                mov     si,offset Btn_Next_txt
                MakeSelect<Btn_Next_no>
                call    WriteStr
                mov     dx,cs:[Btn_FF_xy]
                mov     si,offset Btn_FF_txt
                MakeSelect<Btn_FF_no>
                call    WriteStr
                mov     dx,cs:[Btn_Stop_xy]
                mov     si,offset Btn_Stop_txt
                MakeSelect<Btn_Stop_no>
                call    WriteStr
                mov     dx,cs:[Btn_Pause_xy]
                mov     si,offset Btn_Pause_txt
                MakeSelect<Btn_Pause_no>
                call    WriteStr
                mov     dx,cs:[Btn_Tray_xy]
                mov     si,offset Btn_Tray_txt
                MakeSelect<Btn_Tray_no>
                call    WriteStr

                mov     dx,cs:[Btn_VolU_xy]
                mov     si,offset Btn_VolU_txt
                MakeSelect<Btn_VolU_no>
                call    WriteStr
                mov     dx,cs:[Btn_VolD_xy]
                mov     si,offset Btn_VolD_txt
                MakeSelect<Btn_VolD_no>
                call    WriteStr
                ret
PaintButtons    endp

PaintStatus     proc    near
                inc     cs:[Status_Delay]        ; Delaying
                cmp     cs:[Status_Delay],4
                jb      return_06
                mov     cs:[Status_Delay],0

                mov     dx,Dis_status_xy
                movzx   si,byte ptr cs:[Status_Frame]
                mov     al,byte ptr cs:[AudioStatus]
                cmp     al,paused
                jz      _paused
                cmp     al,stopped
                jz      _stopped
                cmp     al,_unknown_
                jz      _unknown
                add     si,offset StatusPlay_txt
                jmp     WriteStatus
_paused:        add     si,offset StatusPause_txt
                jmp     WriteStatus
_unknown:       add     si,offset StatusUnkn_txt
                jmp     WriteStatus
_stopped:       mov     si,offset StatusStop_txt  ; 'cos not animated
WriteStatus:
                call    WriteStr
                add     byte ptr cs:[Status_Frame],4
                cmp     byte ptr cs:[Status_Frame],12
                jnz     return_06
                mov     byte ptr cs:[Status_Frame],0
return_06:
                ret
PaintStatus     endp

WriteDEC        proc    near                 ; IN: DH - Ycor, DL - Xcor
                                             ;     AX - value
                aam                          ; Conversion from binary to BCD
                add     dh,cs:[y_beg]
                add     dl,cs:[x_beg]
                push    ax
                call    GotoXY
                pop     ax
                push    ax
                xchg    al,ah
                add     al,"0"
                call    PutChar
                inc     dl
                call    GotoXY
                pop     ax
                add     al,"0"
                call    PutChar
                ret
WriteDEC        endp



GetXY           proc    near
                mov     ah,03h
                int     10h
                ret
GetXY           endp

GotoXY          proc    near                 ; IN: DH - Ycor, DL - Xcor
                mov     ah,02h
                mov     bh,cs:[active_page]
                int     10h
                ret
GotoXY          endp

KeyPressed      proc    near                 ; OUT: FZ - not keypressed
                mov     ah,01h
                int     16h
                ret
KeyPressed      endp

ReadKey         proc    near                 ; OUT: AL - ASCII
                xor     ax,ax
                int     16h
                ret
ReadKey         endp

PutChar         proc    near                 ; IN: AL - character
                mov     ah,09h
                mov     bl,cs:[actual_color]
                mov     bh,cs:[active_page]
                mov     cx,1
                int     10h
                ret
PutChar         endp

WriteStr        proc    near                 ; IN: CS:SI - string (nullended)
                                             ;     DH - Ycor, DL - Xcor
                add     dh,cs:[y_beg]
                add     dl,cs:[x_beg]
Writing:
                mov     al,cs:[si]
                or      al,al
                jz      return_02
                call    GotoXY
                call    PutChar
                inc     si
                inc     dl
                jmp     Writing
return_02:
                ret
WriteStr        endp

CheckIfSelect   proc    near
                cmp     al,cs:[selected]
                jnz     Not_selected
                SetColor <Button_sel_attr>
                ret
Not_selected:
                SetColor <Button_attr>
                ret
CheckIfSelect   endp

read_port       proc    near                 ; IN: AL=INDEX, OUT=Value
                mov     dx,03d4h
                out     dx,al
                inc     dx
                in      al,dx
                ret
read_port       endp

write_port      proc    near                 ; IN: AL=INDEX, AH=Value
                mov     dx,03d4h
                out     dx,al
                inc     dx
                mov     al,ah
                out     dx,al
                ret
write_port      endp

Delay           proc    near
                xor     cx,cx
                mov     ah,86h
                int     15h
                ret
Delay           endp

resident_body_end:                           ; Here is end of resident part
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\




;\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Get_PSP         proc    near                 ; Out:  BX - PSP segment
                mov     ah,51h               ; Get PSP segment
                int     21h
                ret
Get_PSP         endp

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
CheckCPU        proc    near
                pushf
                pop     ax
                and     ax,0fffh        ; Clear bits 15..12
                push    ax
                popf
                and     ax,0f000h       ; Is bits 15..12=0 ?
                cmp     ax,0f000h
                jz      CPU286
                and     ax,8000h        ; Is bit 15=0
                cmp     ax,8000h
                jnz     CPU386plus
CPU86:          print   <txt_about>
                print   <txt_cpu>
                print   <txt_cpu_86>
                jmp     Sorry
CPU286:         print   <txt_about>
                print   <txt_cpu>
                print   <txt_cpu_286>
Sorry:          print   <txt_sorry>
                mov     ax,4c01h
                int     21h
CPU386plus:     print   <txt_cpu>
                print   <txt_cpu_386>
                ret
CheckCPU        endp


;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Param_check     proc    near     ; IN:  ES - PSP segment
                                 ; Sprawdza PSP na obecno w parametrach sowa z AX
                xor     cx,cx
                mov     cl,byte ptr es:[80h] ; String length
                or      cl,cl
                jz      Not_Found_
                mov     bx,81h              ; Offset to parameters
_repeat:
                mov     dx,word ptr es:[bx]
                cmp     dl,"a"              ; Convert to UpperCase LSB
                jb      MSB_ToUpper         ; ! I know - Not economical !
                cmp     dl,"z"
                jg      comp
                and     dl,0DFh
MSB_ToUpper:
                cmp     dh,"a"              ; Convert to UpperCase MSB
                jb      comp                ; ! I know - Not economical !
                cmp     dh,"z"
                jg      comp
                and     dh,0DFh
comp:           cmp     al,"*"
                jz      check_MSB
                cmp     dl,al               ; Checking...
                jnz     increase
check_MSB:
                cmp     ah,"*"
                jz      increase
                cmp     dh,ah
                jnz     increase
                jmp     found
increase:
                inc     bx
                loop    _repeat             ; Looping...
Not_Found_:
                clc                         ; Clear CF - Not found
                ret
found:
                stc                         ; Set CF - Something is found
                ret
Param_check     endp

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
CheckIfCDROMed  proc    near            ; IN:  CX - Drive number
                                        ; OUT: FC clean - if not CDROMed
                push    ds
                mov     ax,150Bh
                int     2Fh
                pop     ds
                cmp     bx,0ADADh
                jnz     not_mscdex
                or      ax,ax
                jz      not_cdromed
                stc                     ; Set FC
                ret
not_mscdex:
not_cdromed:
                clc                     ; Clear FC
                ret
CheckIfCDROMed  endp

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
FindCDROMDrive  proc    near        ; OUT:  CL - DriveNo
                xor     cx,cx
                dec     cx
Searching:
                inc     cx
                call    CheckIfCDROMed
                jc      DriveFound
                cmp     cx,"Z"-"A"
                jbe     Searching
                print   <txt_notfound>
                mov     ax,4c01h
                int     21h
DriveFound:
                mov     byte ptr cs:[DriveNo],cl
                print   <txt_workon>
                mov     al,"A"
                add     al,cl
                int     29h
                mov     al,":"
                int     29h
                mov     al,13
                int     29h
                mov     al,10
                int     29h
                ret
FindCDROMDrive  endp

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
FindCDROMNo     proc    near
                mov     ax,":*"
                call    param_check
                jnc     Not_Found

                mov     cx,"Z"-"A"
CheckParam:                              ; Check If User passed drive-spec
                mov     ah,":"
                mov     al,cl
                add     al,"A"
                push    cx
                call    param_check
                pop     cx
                jc      UserSpec
                loop    CheckParam
Not_Found:
                call    FindCDROMDrive
                clc
                ret
UserSpec:
                mov     cs:[DriveNo],cl
                print   <txt_workon>
                mov     al,"A"
                add     al,cl
                int     29h
                mov     al,":"
                int     29h
                mov     al,13
                int     29h
                mov     al,10
                int     29h
                call    CheckIfCDROMed
                jnc     Human_Error
                stc
                ret
Human_Error:    print   <txt_warning>
                stc
                ret
FindCDROMNo     endp

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Free_memory     proc    near                 ; Out:  AX - new segment
                call    Get_PSP
                mov     ds,bx
                mov     es,ds:[2ch]          ; PSP[2ch] - segment rodowiska
                mov     ah,49h
                int     21h                  ; ...i go zwolnienie

                         ; Relokacja w gr na cz PSP
                push    ds                   ; Segment PSP
                pop     es
                mov     di,080h              ; Min safe PSP offset
                push    cs
                pop     ds
                mov     si,offset resident_body_begin
                mov     cx,offset resident_body_end - offset resident_body_begin
                cld
                rep     movsb                ; Przesuwanie o $FF-80h w gre

                mov     ax,cs
                sub     ax,8                 ; In AX return new segment of resident
                ret
Free_memory     endp

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Hook_interrupts proc near                    ; IN:  AX - segment to resident part
                                             ; Regs protected: DS

                mov     fs,ax                ; Linker fucks-up when I try
                                             ; to address via DS, WHY ?

                mov     ax,3508h             ; Keyboard handler
                int     21h
                mov     fs:[old_seg_08h],es
                mov     fs:[old_ofs_08h],bx

                mov     ax,3509h             ; Keyboard handler
                int     21h
                mov     fs:[old_seg_09h],es
                mov     fs:[old_ofs_09h],bx

                mov     ax,3510h             ; BIOS graphix procedures
                int     21h
                mov     fs:[old_seg_10h],es
                mov     fs:[old_ofs_10h],bx

                mov     ax,3513h             ; BIOS graphix procedures
                int     21h
                mov     fs:[old_seg_13h],es
                mov     fs:[old_ofs_13h],bx

;                mov     ax,3521h             ; DOS multiplex
;                int     21h
;                mov     fs:[old_seg_21h],es
;                mov     fs:[old_ofs_21h],bx

                mov     ax,3528h             ; BIOS graphix procedures
                int     21h
                mov     fs:[old_seg_28h],es
                mov     fs:[old_ofs_28h],bx

                push    ds
                push    fs
                pop     ds
                mov     ax,2508h
                mov     dx,offset int_08_handler   ; DS:DX
                int     21h

                mov     ax,2509h
                mov     dx,offset int_09_handler   ; DS:DX
                int     21h

                mov     ax,2510h
                mov     dx,offset int_10_handler   ; DS:DX
                int     21h

                mov     ax,2513h
                mov     dx,offset int_13_handler   ; DS:DX
                int     21h

;                mov     ax,2521h
;                mov     dx,offset int_21_handler   ; DS:DX
;                int     21h

                mov     ax,2528h
                mov     dx,offset int_28_handler   ; DS:DX
                int     21h

                pop     ds
                ret
Hook_interrupts endp


;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Remove_TSR      proc    near                ; Uninstalling from memory

                mov     ax,0FFFFh           ; Hooked entry (is exist ?)
                mov     ebx,request
                int     10h                 ; Hooked function returns
                cmp     ebx,response        ; in AX her CodeSegment
                jnz     not_installed       ; Not installed !

                mov     dx,ax               ; TSR's CodeSegment


                  ; Checking if somebody hook ours interrupts...
                mov     ax,3508h            ; Get int 09h vector
                int     21h
                cmp     bx,offset int_08_handler ; Is There Anybody Out There?
                jnz     remove_failed
                mov     bx,es
                cmp     dx,bx
                jnz     remove_failed

                mov     ax,3509h            ; Get int 09h vector
                int     21h
                cmp     bx,offset int_09_handler ; Is There Anybody Out There?
                jnz     remove_failed
                mov     bx,es
                cmp     dx,bx
                jnz     remove_failed

                mov     ax,3510h            ; Get int 10h vector
                int     21h
                cmp     bx,offset int_10_handler ; Is There Anybody Out There?
                jnz     remove_failed
                mov     bx,es
                cmp     dx,bx
                jnz     remove_failed

                mov     ax,3513h            ; Get int 10h vector
                int     21h
                cmp     bx,offset int_13_handler ; Is There Anybody Out There?
                jnz     remove_failed
                mov     bx,es
                cmp     dx,bx
                jnz     remove_failed

;                mov     ax,3521h            ; Get int 21h vector
;                int     21h
;                cmp     bx,offset int_21_handler ; Is There Anybody Out There?
;                jnz     remove_failed
;                mov     bx,es
;                cmp     dx,bx
;                jnz     remove_failed

                mov     ax,3528h            ; Get int 10h vector
                int     21h
                cmp     bx,offset int_28_handler ; Is There Anybody Out There?
                jnz     remove_failed
                mov     bx,es
                cmp     dx,bx
                jnz     remove_failed


                  ; Ok, all interrupts point to resident body
                mov     es,dx               ; TSR's code segment

                mov     ax,2508h            ; Restore original interrupt
                mov     dx,es:[old_ofs_08h]
                mov     ds,es:[old_seg_08h]
                int     21h

                mov     ax,2509h            ; Restore original interrupt
                mov     dx,es:[old_ofs_09h]
                mov     ds,es:[old_seg_09h]
                int     21h

                mov     ax,2510h            ; Restore original interrupt
                mov     dx,es:[old_ofs_10h]
                mov     ds,es:[old_seg_10h]
                int     21h

                mov     ax,2513h            ; Restore original interrupt
                mov     dx,es:[old_ofs_13h]
                mov     ds,es:[old_seg_13h]
                int     21h

;                mov     ax,2521h            ; Restore original interrupt
;                mov     dx,es:[old_ofs_21h]
;                mov     ds,es:[old_seg_21h]
;                int     21h

                mov     ax,2528h            ; Restore original interrupt
                mov     dx,es:[old_ofs_28h]
                mov     ds,es:[old_seg_28h]
                int     21h

                mov     es,es:[TSR_PSP]     ; TSR's PSP segment
                mov     ah,49h
                int     21h                 ; Free all TSR's memory

                print   <txt_uninst>        ; Uninstalled msg
                ret
not_installed:
                print   <txt_notinst>       ; ERR: Try to uninstall TSR which is not in memo
                mov     ax,4c01h
                int     21h                 ; Uninstall failed

remove_failed:
                print   <txt_not_able>      ; ERR: Somebody fucks ours interrupts
                mov     ax,4c01h
                int     21h                 ; Uninstall failed
Remove_TSR      endp

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Work_On_Params  proc    near
                call    Get_PSP
                mov     es,bx               ; BX - Segment PSP
                mov     TSR_PSP,bx

                cmp     byte ptr es:[80h],0 ; PSP's seg:80h = param length
                jnz     check_uninst
                jmp     check4resident

check_uninst:   mov     ax,'U/'             ; /U - uninstall program
                call    param_check
                jz      uninstal

                mov     ax,"A/"
                call    param_check
                jnz     check_next_01
                print   <txt_onstart>
                call    FindCDROMNo
                mov     cs:[lets_run],TRUE
                call    CD_player
                mov     ax,4c00h
                int     21h

check_next_01:
                mov     ax,":*"
                call    param_check
                jnz     check_next_02
                jmp     check4resident

check_next_02:
                mov     ax,"?/"
                call    param_check
                jnz     check_next_03
                print   <txt_about>
                mov     ax,4c01h
                int     21h
check_next_03:
not_spec:
                print   <txt_unknown>       ; Other, unknown parameter
                mov     ax,4c01h
                int     21h                 ; End of Help part

uninstal:                  ; /U - uninstall program
                call    Remove_TSR          ; Try to uninstall
                mov     ax,4c00h
                int     21h                 ; Uninstalled

check4resident:                             ; Checking for other copy of program in memo
                mov     ax,0FFFFh           ; Hooked entry
                mov     ebx,request
                int     10h
                cmp     ebx,response
                jnz     install             ; Not resident, so let's rock

                print   <txt_resident>      ; Already resident in memo
                mov     ax,4c01h
                int     21h                 ; End of "Check for resident" part

install:
                call    FindCDROMNo
                print   <txt_running>       ; Everything goes ok
                ret                         ; And return to install procs
Work_On_Params  endp


;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;                                  M  A  I  N
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
start:
                print   <txt_intro>
                call    CheckCPU
                call    Work_On_Params      ; Check parameters
                call    Free_memory         ; Free additional unuseful memory
                push    fs
                call    Hook_interrupts     ; Hook interrupts
                pop     fs
                mov     ax,3100h
                mov     dx,offset resident_body_end+0Fh-080h+0100h
                shr     dx,4
                int     21h                 ; TSR

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


                .data

program_name    equ     "CD-player"
program_active  equ     "Shift-F11"

                txt_intro    db program_name,", v0.999b by Piotrek Skowronek - Cracow, Jul 17 1997 [FreeWare]",13,10,"$"

                txt_cpu      db "CPU detected: ","$"
                txt_cpu_86   db "80086/80088/80186.",13,10,"$"
                txt_cpu_286  db "80286.",13,10,"$"
                txt_cpu_386  db "80386 or higher.",13,10,"$"
                txt_sorry    db "              Sorry nead at least 80386.",13,10,"$"

                txt_workon   db "Working on the CD-ROM drive ","$"
                txt_notfound db "FATAL: None of drives is CDROM.",13,10
                             db "       Check if CDROM drivers are installed,",13,10
                             db "       or try to run with CDROM drive letter.",13,10,"$"
                txt_resident db program_name," already installed.",13,10,'$'
                txt_notinst  db program_name," not installed.",13,10,'$'
                txt_not_able db "Not able to Unload ",program_name," from memory.",13,10
                             db "Interrupts captured by another program.",13,10,'$'

                txt_uninst   db program_name," removed from memory.",13,10,'$'

                txt_running  db "Press [",program_active,"] to activate.",13,10,'$'

                txt_onstart  db "INFO: User forced immediate activation,",13,10
                             db "      w/o installation as resident.",13,10,"$"
                txt_warning  db "WARN: This drive currently IS NOT CD-ROMed.",13,10
                             db "      Program may NOT work properly. Check iT.",13,10,"$"
                txt_unknown  db "Improper parameter passed, /? for Help.",13,10,"$"
                txt_about    db 10
                             db "Launch parameters:     X:  - X = CD-ROM drive letter, Ex. E:",13,10
                             db "                             (optional parameter, by default",13,10
                             db "                              auto-detecting first available)",13,10
                             db "                       /A  - Don't resident, only activate",13,10
                             db "                       /U  - Unload ",program_name," from memory",13,10
                             db "                       /?  - This help page",13,10
                             db 10
                             db "If you got any thoughts, views, or suggestions",13,10
                             db "please contact. I really do value your opinion.",13,10
                             db "        Post-Cards are welcome (money too! :-).",13,10
                             db "                    e-mail: skylark@interia.pl",13,10
                             db "                 (if no reply: piter@adfinem.net)",13,10
                             db 10
                             db "Activation:   ",program_active," and Text-Mode",13,10
                             db "Requirements: 80386+",13,10,10,"$"
                .stack

                end start